<%@page contentType="text/html;charset=UTF-8"%>
<%@ taglib prefix="f" uri="http://java.sun.com/jsf/core" %>
<%@ taglib prefix="h" uri="http://java.sun.com/jsf/html" %>
<%@ taglib prefix="s" uri="http://shale.apache.org/core" %>
<%@ taglib prefix="val" uri="http://shale.apache.org/validator" %>
<%@ taglib prefix="vc" uri="http://shale.apache.org/view" %>

<%--

 Licensed to the Apache Software Foundation (ASF) under one or more
 contributor license agreements.  See the NOTICE file distributed with
 this work for additional information regarding copyright ownership.
 The ASF licenses this file to you under the Apache License, Version 2.0
 (the "License"); you may not use this file except in compliance with
 the License.  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.

--%>

<f:view>
<%@include              file="../messages.jspf"%>
<html>
<head>
<title>
  <h:outputText        value="#{messages['validate.test.title']}"/>
</title>
</head>
<body>
  <vc:subview id="subview">
  <h:form                 id="form"
                    onsubmit="return validateForm(this);">

    <h:outputText      value="#{messages['validate.test.payment.heading']}"
                       style="font-size: 1.2em;"/>
    <p>
    <h:panelGrid          id="grid"
                     columns="3">

      <h:outputLabel     for="amount"
                       value="#{messages['validate.test.amount']}"/>

      <h:outputText value="#{messages['validate.test.currency.symbol']}"/>

      <h:panelGroup>
         <h:inputText     id="amount"
                       value="#{validate$test.amount}"
                        size="7">

            <f:convertNumber
           minFractionDigits="2"/>

            <val:commonsValidator
                        type="floatRange"
                         min="10"
                         max="1000"
                         arg="#{messages['validate.test.amount']}"
                      server="true"
                      client="false"/>

         </h:inputText>

         <h:message      for="amount"
                       style="color: red; font-style: italic;"/>
      </h:panelGroup>

      <h:outputLabel     for="creditCard"
                       value="#{messages['prompt.creditCardNumber']}"/>

      <h:outputText    value=""/>

      <h:panelGroup>
         <h:inputText     id="creditCard"
                        size="11"
                       value="#{validate$test.creditCard}">

            <val:commonsValidator
                        type="required"
                         arg="#{messages['prompt.creditCardNumber']}"
                     server="true"
                     client="false"/>

            <val:commonsValidator
                        type="creditCard"
                         arg="#{messages['prompt.creditCardNumber']}"
                      server="true"
                      client="false"/>

            <val:commonsValidator type="mask"
                       mask="[4-6].*"
                    message="#{messages['validate.test.unknown.credit.card.type']}"
                     server="false"
                     client="true"/>

         </h:inputText>

         <h:message      for="creditCard"
                       style="color: red; font-style: italic;"/>
      </h:panelGroup>

      <h:outputText value="#{messages['prompt.expirationDate']}"/>

      <h:outputText    value=""/>

      <h:panelGroup>
        <h:inputText     id="date"
                      value="#{validate$test.expirationDate}">

          <f:convertDateTime
                     pattern="MM/dd/yyyy"/>

            <val:commonsValidator
                        type="required"
                        arg="#{messages['prompt.expirationDate']}"
                     server="false"
                     client="true"/>

          <val:commonsValidator
                       type="date"
          datePatternStrict="MM/dd/yyyy"
                    message="#{messages['validate.test.bad.expiration.date']}"
                        arg="#{messages['prompt.expirationDate']}"
                     server="false"
                     client="true"/>

       </h:inputText>

       <h:message       for="date"
                       style="color: red; font-style: italic;"/>

      </h:panelGroup>

      <h:outputText    value=""/>
      <h:outputText    value=""/>
      <h:outputText    value=""/>

      <h:commandButton value="Submit"
                      action="validate$thankYou"/>

    </h:panelGrid>

	 <f:verbatim><p></f:verbatim>

	 <h:outputText     value="#{messages['validate.test.description']}"
	                  escape="false"
	                   style="font-style: italic"/>

    <f:verbatim><p></f:verbatim>


    <h:commandLink
                 immediate="true"
                     value="#{messages['usecases.primary']}"
                    action="usecases$toplevel"/>


  </h:form>
</vc:subview>

<br/><br/>
<p>
The second part of this example doesn't match the credit card example above.
The goal was to show client side validation using multiple html forms on the
same page.</p>

<p>
This example lists some procedures in a dataTable.  The billed amount must be
within the allowable range for each procedure.  We are demonstrating client
side validation within a dataTable.  Another interesting twist is that the
variables used in the validation of each row are defined using a value
binding expression and are specific to the procedure.</p>

<vc:subview id="cptSubview">
    <h:form id="cptForm" onsubmit="return validateForm(this);">
        <h:dataTable var="e" rows="3" value="#{validate$test.procedures}">
                  <h:column>
                     <f:facet name="header">
                        <h:outputText value="CPT"/>
                     </f:facet>
                     <h:outputText value="#{e.cpt}"/>
                  </h:column>

                  <h:column>
                     <f:facet name="header">
                         <h:outputText value="Procedure"/>
                     </f:facet>
                     <h:outputText value="#{e.descr}"/>
                  </h:column>

                  <h:column>
                     <f:facet name="header">
                         <h:outputText value="Amount"/>
                     </f:facet>
                     <h:inputText id="amount" value="#{e.billedAmt}">
                       <f:convertNumber minFractionDigits="2"/>
                       <val:commonsValidator type="floatRange" server="true"  client="true">
                         <val:validatorVar name="arg" value="Amount" />
                         <val:validatorVar name="min" value="#{e.minAmt}"/>
                         <val:validatorVar name="max" value="#{e.maxAmt}"/>
                       </val:commonsValidator>
                     </h:inputText>
                  </h:column>
        </h:dataTable>
        <br/><br/>

        <h:commandButton value="Submit" action="validate$thankYou"/>

        <br/><br/>
        <h:commandLink
                 immediate="true"
                     value="#{messages['usecases.primary']}"
                    action="usecases$toplevel"/>

    </h:form>
</vc:subview>
  
  <br/><br/>
  <p>The third part of this example deals with using custom validation rules.  
      Priority must be an even integer.</p>
  
  <f:subview id="cvrSubview">
      <h:form id="cvrForm" onsubmit="return validateForm(this);">

          <h:panelGrid    columns="3">

          <h:outputText value="#{messages['prompt.priority']}"/>
          <h:inputText     id="priority"
                        value="#{priority}">
              <val:commonsValidator
                          type="required"
                          arg="#{messages['prompt.priority']}"
                       server="true"
                       client="false"/>
              <val:commonsValidator
                     type="evenInteger"
                   server="true"
                   client="false"/>
          </h:inputText>
           <h:message           for="priority" styleClass="errors"/>

     </h:panelGrid>

          <br/><br/>

          <h:commandButton value="Submit" action="validate$thankYou"/>

          <br/><br/>
          <h:commandLink
                   immediate="true"
                       value="#{messages['usecases.primary']}"
                      action="usecases$toplevel"/>

      </h:form>
  </f:subview>

<val:validatorScript functionName="validateForm"/>

</body>
</html>
</f:view>
